<template>
  <PageTemplate v-if="album" v-loading="loading" :data="album" type="album" />
</template>

<script lang="ts">
import {
  defineComponent,
  useAsync,
  useContext,
  useMeta,
  ref
} from '@nuxtjs/composition-api'
import { AlbumFragment } from '@/sdk/types'
import { useGetAlbumQuery } from '@/sdk/hooks'
import PageTemplate from '@/components/template/PublicPage.vue'
export default defineComponent({
  layout: 'single',
  name: 'EventPage',
  components: { PageTemplate },
  head: {},
  setup(_, { root }) {
    const { app, route, error } = useContext()
    const { onResult, loading } = useGetAlbumQuery(
      {
        id: root.$route.params.id
      },
      {
        fetchPolicy: 'network-only'
      }
    )
    const meta = useMeta()
    // const album = ref<AlbumFragment>([] as any)
    // if (process.client) {
    //   onResult(result => {
    //     if (!result?.data?.album) {
    //       return error({ statusCode: 404 })
    //     }
    //     album.value = result.data.album
    //     meta.title.value =
    //       album.value?.name + ' by ' + album.value?.user.display_name
    //     meta.meta.value = [
    //       {
    //         hid: 'og:image',
    //         property: 'og:image',
    //         content: `/storage/${album.value?.cover?.preview_url}`
    //       },
    //       {
    //         hid: 'description',
    //         name: 'description',
    //         content: album.value?.comment
    //       }
    //     ]
    //   })
    // }
    const album = useAsync<AlbumFragment>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.album) {
              return error({ statusCode: 404 })
            }
            const album = result.data.album
            meta.title.value = album?.name + ' by ' + album?.user.display_name
            meta.meta.value = [
              {
                hid: 'og:image',
                property: 'og:image',
                content: `/storage/${album?.cover?.preview_url}`
              },
              {
                hid: 'description',
                name: 'description',
                content: album?.comment
              }
            ]
            resolve(album)
          })
        )
    )
    if (process.client) {
      onResult(result => {
        if (!result?.data?.album) {
          return error({ statusCode: 404 })
        }
        album.value = result.data.album
        meta.title.value =
          album.value?.name + ' by ' + album.value?.user.display_name
        meta.meta.value = [
          {
            hid: 'og:image',
            property: 'og:image',
            content: `/storage/${album.value?.cover?.preview_url}`
          },
          {
            hid: 'description',
            name: 'description',
            content: album.value?.comment
          }
        ]
      })
    }

    return {
      album,
      loading
    }
  }
})
</script>

<style lang="scss" scoped></style>
